image: maven:latest

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  TAG: ${CI_PIPELINE_IID}

cache:
  paths:
    - .m2/repository/
    - target/

build:
  stage: build
  script:
    - mvn $MAVEN_CLI_OPTS compile

test:
  stage: test
  script:
    - mvn $MAVEN_CLI_OPTS test
    - echo done

jib:
  stage: deploy
  script:
    - mvn compile jib:build -Djib.to.auth.username=${CI_REGISTRY_USER} -Djib.to.auth.password=${CI_REGISTRY_PASSWORD} -Djib.to.image=registry.gitlab.com/kamradtfamily.net/sync-service:$TAG

update_manifest:
  stage: deploy
  image:
    name: alpine/helm:3.5.3
  variables:
    GIT_STRATEGY: none
    CD_GIT_REPOSITORY: git@gitlab.com:kamradtfamily.net/helm-charts.git
    CD_CHART_REPO: sync-service
    CD_MANIFEST_FILE: Chart.yaml
  script:
    # get stuffs
    - echo 'http://dl-cdn.alpinelinux.org/alpine/v3.11/community' >> /etc/apk/repositories
    - apk update
    - apk add git
    - apk add perl
    - apk add openssh
    - wget https://github.com/mikefarah/yq/releases/download/v4.30.6/yq_linux_amd64 -O /usr/bin/yq
    - chmod +x /usr/bin/yq
    # Add SSH key to root
    - mkdir -p /root/.ssh
    - cp "$SSH_PRIVATE_KEY" /root/.ssh/id_rsa
    - ssh-keyscan -H gitlab.com > /root/.ssh/known_hosts
    - chmod 600 /root/.ssh/id_rsa
    # Git
    - git clone --single-branch --branch main $CD_GIT_REPOSITORY
    - cd helm-charts/$CD_CHART_REPO
    - git config user.name gitlab.runner
    - git config user.email "gitlab.runner@gitlab.com"
    # Helm
    - yq e .appVersion=\"$TAG\" -i $CD_MANIFEST_FILE
    - cat $CD_MANIFEST_FILE
    - git commit -am "update image tag to ${TAG}" && git push

sonarqube-check:
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - mvn verify sonar:sonar -Dsonar.projectKey=kamradtfamily.net_sync-service_AYW2DP9ADnrasZpneZWX
  allow_failure: true
  only:
    - main
